﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace pr269_3
{
    // Обобщенный класс c одним параметром: 
    class MyClass<X>
    {
        // Поле обобщенного типа: 
        private X[] mas; // Массив
        private int n; // Количество элементов массива 
        // Конструктор: 
        public MyClass(X[] t)
        {
            n = t.Length;
            mas = t;
        }
        // Операторный метод для перегрузки оператора сложения: 
        public static MyClass<X> operator+(MyClass<X> a, MyClass<X> b)
        {
            // Размер массива: 
            int m = a.mas.Length + b.mas.Length;
            X[] arg = new X[m]; // Создание массива
            // Заполнение массива:
            for (int i = 0; i < m; i++)
            {
                if (i < a.mas.Length)
                    arg[i] = a.mas[i];
                else
                    arg[i] = b.mas[i - a.mas.Length];
            }
            // Результат метода: экземплар класса
            return new MyClass<X>(arg);
        }
        // Метод, выводящий элементы массива:
        public void show()
        {
            string txt = "|";
            for (int i = 0; i < mas.Length; i++)
                txt += mas[i] + "|";
            Console.WriteLine("Поле типа {0}: {1}", typeof(X).Name, txt);
        }
    }

    class Program
    {
        static void Main()
        {
            // Создание числовых массивов:
            int[] a1 = { 3, 5, 17 };
            int[] a2 = { 9, 7 };
            // Объекты обобщенного класса:
            MyClass<int> A1 = new MyClass<int>(a1);
            MyClass<int> A2 = new MyClass<int>(a2);
            // Сложили объекты обобщенного класса:
            MyClass<int> A3 = A1 + A2;
            // Вывод результатов:
            A1.show();
            A2.show();
            A3.show();
            // Создание символьных массивов:
            char[] ch1 = { 'a', 'b' };
            char[] ch2 = { 'x', 'y', 'z' };
            // Объекты обобщенного класса:
            MyClass<char> CH1 = new MyClass<char>(ch1);
            MyClass<char> CH2 = new MyClass<char>(ch2);
            // Сложили объекты обобщенного класса:
            MyClass<char> CH3 = CH2 + CH1;
            // Вывод результатов:
            CH1.show();
            CH2.show();
            CH3.show();
            // Задержка:
            Console.ReadLine();
        }
    }
}
